#!/usr/local/bin/ruby -w
#-*-Ruby-*-
# $Id: mhcmonthly1.cgi,v 1.3 2001-02-02 14:52:50+09 oharakun Exp oharakun $

require "web-mhc-conf"
require "web-mhc"
require "mhc-date"
require "mhc-schedule"
require "cgi"
require "kconv"

######################################################################
### Intializations
######################################################################

$query = CGI::new

Now = Time.now
NowYear, NowMon, NowDay = Now.year, Now.mon, Now.day

if ($query['month'][0] =~ /^(\d\d\d\d)\/(\d\d)$/)
  year, mon = $1.to_i, $2.to_i
elsif ($query['month'][0] =~ /^(\d\d)$/)
  year, mon = NowYear, $1.to_i
else
  year, mon = NowYear, NowMon
end

NextTarget = "schedule"

MHCMONTHLY1_TITLE_FONT = "h1" unless (defined?(MHCMONTHLY1_TITLE_FONT))

######################################################################
### SubRoutines
######################################################################

def mkMonthlyTbl(year, mon)
  yyyymmdd = sprintf("%04d%02d01", year, mon)
  str = ''
  str << "<table border=1>\n"
  str << "<tr><th>date</th><th>time</th><th>schedule</th></tr>\n"
  str << "<tr><td colspan=3></td></tr>\n"

  sDB = MhcScheduleDB::new
  sDB.m_search(MhcDate::new(yyyymmdd)).each { |date, items|
    if (items.size == 0)
      str << "<tr><td><a name=#{date.d_s1}>#{date.md_s1('/')}</a></td>"
      str << "<td><br></td><td><br></td></tr>\n"
    else
      date_anchor = true
      items.each { |sch|
	if (date_anchor)
	  str << "<tr><td><a name=#{date.d_s1}>#{date.md_s1('/')}</a></td>"
	  date_anchor = false
	else
	  str << "<tr><td><br></td>"
	end

	time_as_string = (sch.time_as_string == '') ? "<br>" : sch.time_as_string
	str << "<td>#{time_as_string}</td>"
	if (sch.path)
	  str << "<td><a href=\"#{MHCCAT}?date=#{date.to_s1}&amp;path=#{substrPath(sch.path)}&amp;type=html\""
	  str << " target=\"#{NextTarget}\">#{Kconv::tojis(CGI::escapeHTML(Kconv::toeuc(sch.subject)))}</a></td></tr>\n"
	else
	  str << "<td>#{Kconv::tojis(CGI::escapeHTML(Kconv::toeuc(sch.subject)))}</td></tr>\n"
	end
      }
    end
  }

  str << "</table>\n"

  str
end

######################################################################
### Main
######################################################################

py, pm = getPrevMonth(year, mon)
ny, nm = getNextMonth(year, mon)

theMonth = getMonthStr(year, mon)
prevMonth = getMonthStr(py, pm)
nextMonth = getMonthStr(ny, nm)

print "Content-Type: text/html\n"
print "\n"

print <<EOH
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang=ja>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-2022-JP">
<title>MHC Monthly Index (#{theMonth})</title>
</head>

EOH

print "<body>\n"

if (defined?(MHCMONTHLY1_TITLE) && MHCMONTHLY1_TITLE != '')
  print "\n<#{MHCMONTHLY1_TITLE_FONT}>"
  print "#{Kconv::tojis(MHCMONTHLY1_TITLE)}"
  print "</#{MHCMONTHLY1_TITLE_FONT}>\n"
end

print <<EOT

<table width="100%"><tr>

<td align=left>
[<a href="#{MHCMONTHLY1}?month=#{prevMonth}">#{prevMonth}</a>]
&lt;&lt;
[#{theMonth}]
&gt;&gt;
[<a href="#{MHCMONTHLY1}?month=#{nextMonth}">#{nextMonth}</a>]
</td>

<td align=right>
<a href="#{MAIN}?duration=3" target="_top">3 months index</a>
</td>

</tr></table>

EOT

tbl = mkMonthlyTbl(year, mon)
print tbl

print <<EOT

</body>
</html>
EOT

exit 0
