#!/usr/local/bin/ruby
#-*-Ruby-*-
# $Id: mhcmonthly3.cgi,v 1.2 2001-02-02 14:47:50+09 oharakun Exp oharakun $

require "web-mhc-conf"
require "web-mhc"
require "mhc-schedule"
require "mhc-date"
require "cgi"
require "kconv"

######################################################################
### Intializations
######################################################################

$query = CGI::new

Now = Time::now
NowYear, NowMon, NowDay = Now.year, Now.mon, Now.day

if ($query['month'][0] =~ /^(\d\d\d\d)\/(\d\d)$/)
  year, mon = $1.to_i, $2.to_i
elsif ($query['month'][0] =~ /^(\d\d)$/)
  year, mon = NowYear, $1.to_i
else
  year, mon = NowYear, NowMon
end

NextTarget = "daily"

MHCMONTHLY3_TITLE_FONT = "h1" unless (defined?(MHCMONTHLY3_TITLE_FONT))

######################################################################
### SubRoutines
######################################################################

def mkCalTbl(year, mon)
  yyyy = sprintf("%04d", year)
  mm = sprintf("%02d", mon)

  sDB = MhcScheduleDB::new

  ary = mkCalAry(year, mon)

  str = ''
  str << "<table border=1>\n"

  str << "<tr>\n"
  WKLABEL.each { |w|
    str << "<th><tt><font color=\"#{WKCOLOR[w]}\">#{w}</font></tt></th>\n"
  }
  str << "</tr>\n"

  str << "<tr><td colspan=7></td></tr>\n"

  ary.each { |w|
    str << "<tr>\n"
    w.each { |d|
      str << "<td align=right"
      if (NowDay == d && NowMon == mon && defined?(TODAY_COLOR))
	str << " bgcolor=\"#{TODAY_COLOR}\""
      end
      str << ">"

      if (d == nil)
	str << "<br>"
      else
	s = sDB.search1(MhcDate::new(year.to_i, mon.to_i, d))
	if (s.empty?)
	  str << "#{d}"
	else
	  dd = sprintf("%02d", d)
	  str << "<a href=\"#{MHCDAILY}?day=#{yyyy}/#{mm}/#{dd}\""
	  str << " target=\"#{NextTarget}\">#{d}</a>"
	end
      end

      str << "</td>\n"
    }
    str << "</tr>\n"
  }

  str << "</table>\n"

  str
end

######################################################################
### Main
######################################################################

py, pm = getPrevMonth(year, mon)
ny, nm = getNextMonth(year, mon)

theMonth = getMonthStr(year, mon)
prevMonth = getMonthStr(py, pm)
nextMonth = getMonthStr(ny, nm)

print "Content-Type: text/html\n"
print "\n"

print <<EOH
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang=ja>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-2022-JP">
<title>MHC Monthly Index (#{theMonth})</title>
</head>

EOH

print "<body>\n"

if (defined?(MHCMONTHLY3_TITLE) && MHCMONTHLY3_TITLE != '')
  print "\n<#{MHCMONTHLY3_TITLE_FONT}>"
  print "#{Kconv::tojis(MHCMONTHLY3_TITLE)}"
  print "</#{MHCMONTHLY3_TITLE_FONT}>\n"
end

print <<EOT

<table width="100%"><tr>

<td align=left>
[<a href="#{MHCMONTHLY3}?month=#{prevMonth}">#{prevMonth}</a>]
&lt;&lt;
[#{theMonth}]
&gt;&gt;
[<a href="#{MHCMONTHLY3}?month=#{nextMonth}">#{nextMonth}</a>]
</td>

<td align=right>
<a href="#{MAIN}?duration=1" target="_top">1 month index</a>
</td>

</tr></table>

<table><tr>

<td>
<div align=center><p>#{prevMonth}</p></div>
#{mkCalTbl(py, pm).chomp!}
</td>

<td>
<div align=center><p>#{theMonth}</p></div>
#{mkCalTbl(year, mon).chomp!}
</td>

<td>
<div align=center><p>#{nextMonth}</p></div>
#{mkCalTbl(ny, nm).chomp!}
</td>

</tr></table>

</body>
</html>
EOT

exit 0
