#!/usr/local/bin/ruby
#-*-Ruby-*-
# $Id: web-mhc.rb,v 1.1 2001-02-02 14:48:12+09 oharakun Exp oharakun $

require "date"
require "cgi"

######################################################################
### SubRoutines
######################################################################

WKLABEL = %w(Sun Mon Tue Wed Thu Fri Sat)

WKCOLOR = {
  'Sun' => 'red',
  'Mon' => 'black',
  'Tue' => 'black',
  'Wed' => 'black',
  'Thu' => 'black',
  'Fri' => 'black',
  'Sat' => 'blue',
}

def getNextMonth(year, mon)
  if (mon >= 12)
    return year + 1, 1
  else
    return year, mon + 1
  end
end

def getPrevMonth(year, mon)
  if (mon <= 1)
    return year - 1, 12
  else
    return year, mon - 1
  end
end

def getMonthStr (year, mon)
  return sprintf("%04d", year) + '/' + sprintf("%02d", mon)
end

def substrPath(str)
  str.sub!(/^.+\/(\d+\/\d+\/\d+)$/) { $1 }
  str
end

def mkCalAry(year, mon)
  first = Date::new3(year, mon, 1)
  calAry = []
  zilch = 1 - first.wday
  limit = ((first >> 1) - 1).day

  for i in 0..5
    calAry[i] = []
    n = zilch + 7 * i
    for j in 0..6
      d = (n + j < 1 || limit < n + j) ? nil : n + j
      calAry[i].push(d)
    end
  end

  calAry
end
